* {
  // padding: 0;
  background-clip: padding-box;

  -GtkToolButton-icon-spacing: 0;
  -GtkTextView-error-underline-color: $error;

  // The size for scrollbars. The slider is 2px smaller, but we keep it
  // up so that the whole area is sensitive to button presses for the
  // slider. The stepper button is larger in both directions, the slider
  // only in the width

  -GtkScrolledWindow-scrollbar-spacing: 0;

  -GtkToolItemGroup-expander-size: 11;

  -GtkWidget-text-handle-width: 24;
  -GtkWidget-text-handle-height: 24;

  -GtkDialog-button-spacing: 4;
  -GtkDialog-action-area-border: 0;

  // We use the outline properties to signal the focus properties
  // to the adwaita engine: using real CSS properties is faster,
  // and we don't use any outlines for now.

  outline-style: solid;
  outline-width: 2px;
  outline-color: transparent;
  outline-offset: -4px;
  -gtk-outline-radius: $corner-radius;

  -gtk-secondary-caret-color: $primary;

  &:focus { outline-color: $overlay-checked; }
}


/***************
 * Base States *
 ***************/
.background {
  background-color: $background;
  color: $text;
}

/*
   These wildcard seems unavoidable, need to investigate.
   Wildcards are bad and troublesome, use them with care,
   or better, just don't.
   Everytime a wildcard is used a kitten dies, painfully.
*/

*:disabled { -gtk-icon-effect: dim; }

.gtkstyle-fallback {
  background-color: $background;
  color: $text;

  &:hover {
    background-color: darken($background, 5%);
    color: $text;
  }

  &:active {
    background-color: darken($background, 10%);
    color: $text;
  }

  &:disabled {
    background-color: $background;
    color: $text-disabled;
  }

  &:selected {
    background-color: $primary;
    color: on($primary);
  }
}

.view {
  // @extend row.activatable;

  background-color: $base;
  color: $text;

  &:hover { box-shadow: inset 0 0 0 9999px $overlay-hover; }

  &:selected:hover { box-shadow: inset 0 0 0 9999px rgba($primary, 0.08); }

  &:disabled { color: $text-disabled; }

  &:hover, &:selected { border-radius: $corner-radius; }

  selection,
  &:selected { @extend %selected_items; }
}

textview {
  // FIXME: we need to override background-color to ensure text rendering
  text { background-color: $base; }

  border {
    background-color: $base-alt;
    color: $text-secondary; // FIXME: not working
  }
}

// iconview { @extend .view; }

.rubberband,
rubberband {
  border: 1px solid $primary-alt;
  background-color: rgba($primary-alt, 0.3);
}

flowbox {
  rubberband { @extend rubberband; }

  flowboxchild {
    padding: 4px;
    border-radius: $corner-radius;

    &:selected { @extend %selected_items; }
  }
}

.content-view .tile {
  // margin: 2px;
  // padding: 0;
  // border-radius: 0;
  // background-color: black;

  &:selected {
    background-color: transparent;
  }
}

label {
  caret-color: currentColor; // this shouldn't be needed.

  &.separator {
    @extend .dim-label;

    color: $text;
  }

  selection { @extend %selected_items; }

  &:disabled {
    color: $text-disabled;

    // selection { @extend %selected_items:disabled; }

    headerbar &,
    tab &,
    button & { color: inherit; }
  }
}

.dim-label { opacity: 0.6; }

assistant {
  .sidebar {
    padding: 4px 0;
    // background-color: $base;
    // border-top: 1px solid $border;
  }

  // &.csd .sidebar { border-top-style: none; }

  .sidebar label {
    min-height: $medium-size;
    padding: 0 12px;
    color: $text-disabled;
    font-weight: 500;

    &.highlight { color: $text; }
  }
}

// %osd, .osd { opacity: 0.9; }


/*********************
 * Spinner Animation *
 *********************/
@keyframes spin {
  to { -gtk-icon-transform: rotate(1turn); }
}

spinner {
  background: none;
  opacity: 0; // non spinning spinner makes no sense
  -gtk-icon-source: -gtk-icontheme('process-working-symbolic');

  &:checked {
    opacity: 1;
    animation: spin 1s linear infinite;

    &:disabled { opacity: 0.5; }
  }
}


/****************
 * Text Entries *
 ****************/
%entry,
entry {
  %entry_basic, & {
    min-height: $medium-size;
    padding: 0 8px;
    border-radius: $corner-radius $corner-radius 0 0;
    caret-color: currentColor; // this shouldn't be needed.

    @include entry(normal);

    &:focus { @include entry(focus); }

    &:disabled { @include entry(disabled); }

    &.flat {
      min-height: 0;
      padding: 2px;
      border-radius: 0;
      background-color: transparent;
    }

    image { // icons inside the entry
      // @extend %simple_flat_button;

      // min-height: $small-size;
      // min-width: $small-size;
      // border-radius: $circular-radius;
      // -gtk-outline-radius: $circular-radius;
      color: $text-secondary;

      &:hover, &:active { color: $text; }

      &:disabled { color: $text-disabled; }

      &.left {
        margin-left: ($medium-size - 16px) / 2 - 8px;
        margin-right: 6px;
      }

      &.right {
        margin-left: 6px;
        margin-right: ($medium-size - 16px) / 2 - 8px;
      }
    }

    undershoot {
      &.left { @include undershoot(left); }

      &.right { @include undershoot(right); }
    }

    selection { @extend %selected_items; }

    // entry error and warning style
    @each $e_type, $e_color in (error, $error),
                               (warning, $warning) {
      &.#{$e_type} {
        @include entry(normal, $e_color);

        &:focus { @include entry(focus, $e_color); }

        &:disabled { @include entry(disabled, $e_color); }
      }
    }

    &:drop(active) {
      // box-shadow: inset 0 0 0 2px $primary;
    }

    .osd & {
    }
  }

  progress {
    margin: 2px -8px;
    border-bottom: 2px solid $primary;
    background-color: transparent;
  }

   // linked entries
  .linked:not(.vertical) > & { @extend %linked_entry; }

  // Vertically linked entries
  .linked.vertical > & { @extend %linked_vertical_entry; }
}

%entry_raised {
  border-radius: $corner-radius;

  @include entry(raised-normal);

  &:focus { @include entry(raised-focus); }

  &:disabled { @include entry(raised-disabled); }

  // entry error and warning style
  @each $e_type, $e_color in (error, $error),
                             (warning, $warning) {
    &.#{$e_type} {
      @include entry(raised-normal, $e_color);

      &:focus { @include entry(raised-focus, $e_color); }

      &:disabled { @include entry(raised-disabled, $e_color); }

      image {
        color: on($e_color, secondary);

        &:hover, &:active { color: on($e_color); }

        &:disabled { color: on($e_color, disabled); }
      }
    }
  }
}

treeview entry {
  &.flat, & {
    background-color: $base;

    &, &:focus {
      border-image: none;
      box-shadow: none;
    }
  }
}

.entry-tag {
  margin: 2px;
  border-radius: $circular-radius;
  box-shadow: none;
  background-color: $divider;
  color: $text;

  &:hover { background-image: image($divider); }

  // side margins: compensate the entry padding with a negative margin
  // then the negative margin itself
  :dir(ltr) & {
    margin-left: 4px;
    margin-right: 0;
    padding-left: 12px;
    padding-right: 8px;
  }

  :dir(rtl) & {
    margin-left: 0;
    margin-right: 4px;
    padding-left: 8px;
    padding-right: 12px;
  }

  // seems any sizing doesn't work
  &.button {
    box-shadow: none;
    background-color: transparent;

    &:not(:hover):not(:active) { color: $text-secondary; }
  }
}


/***********
 * Buttons *
 ***********/
// stuff for .needs-attention
@keyframes needs_attention {
  from {
    background-image: -gtk-gradient(radial,
                                    center center, 0,
                                    center center, 0.001,
                                    to($primary),
                                    to(transparent));
  }

  to {
    background-image: -gtk-gradient(radial,
                                    center center, 0,
                                    center center, 0.5,
                                    to($primary),
                                    to(transparent));
  }
}

%button,
button {
  @at-root %button_basic, & {
    min-height: 24px;
    min-width: 16px;
    padding: ($medium-size - 24px) / 2 ($medium-size - 16px) / 2;
    border-radius: $corner-radius;
    font-weight: 500;

    @include button(normal);

    &:hover { @include button(hover); }

    &:active { @include button(active); }

    &:disabled { @include button(disabled); }

    &:checked { @include button(checked); }

    &:checked:disabled { @include button(checked-disabled); }

    @at-root %flat_button, &.flat {
      @at-root %simple_flat_button, & {
        @include button(flat-normal);

        &:hover { @include button(flat-hover); }

        &:active { @include button(flat-active); }

        &:disabled { @include button(flat-disabled); }
      }

      &:checked { @include button(flat-checked); }

      &:checked:disabled { @include button(flat-checked-disabled); }
    }

    &.text-button {
      padding-left: 16px;
      padding-right: 16px;
    }

    &.image-button {
      min-width: 24px;
      padding: ($medium-size - 24px) / 2;

      @extend %circular_button;
    }

    &.text-button.image-button {
      border-radius: $corner-radius;
      -gtk-outline-radius: $corner-radius;

      label {
        &:first-child { margin-left: 16px - ($medium-size - 24px) / 2; }

        &:last-child { margin-right: 16px - ($medium-size - 24px) / 2; }
      }

      image:not(:only-child) { margin: 0 (24px - 16px) / 2; }
    }

    .linked > & { @extend %linked; }

    .linked.vertical > & { @extend %linked_vertical; }

    .linked > &.flat,
    .linked.vertical > &.flat {
      border-radius: $corner-radius;

      &.image-button { @extend %circular_button; }

      &.text-button.image-button {
        border-radius: $corner-radius;
        -gtk-outline-radius: $corner-radius;
      }
    }

    &:drop(active) {
      // box-shadow: inset 0 0 0 2px $primary;
    }
  }

  @at-root %button_selected {
    &.flat {
      color: on(dark, secondary);

      &:hover, &:active { color: on(dark); }

      &:disabled { color: on(dark, secondary-disabled); }

      &:checked {
        background-color: on(dark, track);
        color: on(dark);
      }

      &:checked:disabled {
        background-color: on(dark, divider);
        color: on(dark, disabled);
      }
    }
  }

  // big standalone buttons like in Documents pager
  &.osd {
    padding: ($large-size - 24px) / 2 ($large-size - 16px) / 2;

    &.image-button { padding: ($large-size - 24px) / 2; }

    &:disabled { opacity: 0; }
  }

  // overlay / OSD style
  @at-root %osd_button,
  .osd & {
  }

  // Suggested and Destructive Action buttons
  @each $b_type, $b_color in (suggested-action, $suggested),
                             (destructive-action, $destructive) {
    &.#{$b_type} {
      background-color: $b_color;
      color: on($b_color);

      &:disabled { @include button(disabled); }

      &:checked { background-color: mix(on($b_color), $b_color, percentage(0.3)); }

      &.flat {
        background-color: transparent;
        color: $b_color;

        &:disabled { @include button(flat-disabled); }

        &:checked { background-color: rgba($b_color, 0.3); }
      }

      .osd & {
      }
    }
  }

  .stack-switcher > & {
    // to position the needs attention dot, padding is added to the button
    // child, a label needs just lateral padding while an icon needs vertical
    // padding added too.

    outline-offset: -4px; // needs to be set or it gets overriden by GtkRadioButton outline-offset

    > label {
      padding-left: 6px;  // label padding
      padding-right: 6px; //
    }

    > image {
      padding-left: 6px;   // image padding
      padding-right: 6px;  //
      padding-top: 3px;    //
      padding-bottom: 3px; //
    }

    &.text-button {
      // compensate text-button paddings
      padding-left: 16px - 6px;
      padding-right: 16px - 6px;
    }

    &.image-button {
      // we want image buttons to have a 1:1 aspect ratio, so compensation
      // of the padding added to the GtkImage is needed
      padding-left: ($medium-size - 16px) / 2 - 6px;
      padding-right: ($medium-size - 16px) / 2 - 6px;
    }

    &.needs-attention {
      > label,
      > image { @extend %needs_attention; }

      &:checked {
        > label,
        > image {
          animation: none;
          background-image: none;
        }
      }
    }
  }

  // hide separators
  &.font,
  &.file { separator { @extend %hide_separators; }}

  // &.font { > box > box > label { font-weight: bold; }}

  // inline-toolbar buttons
  .inline-toolbar & {
    // @extend %button_basic.flat;

    &:not(.text-button) { @extend %circular_button; }
  }

  .primary-toolbar & { -gtk-icon-shadow: none; } // tango icons don't need shadows

  @at-root %circular_button,
  &.close,
  &.circular { // The Bloody Circul Button
    border-radius: $circular-radius;
    -gtk-outline-radius: $circular-radius;

    // label { padding: 0; }
  }

  @at-root %small_button {
    min-height: $small-size;
    min-width: $small-size;
    padding: 0;
    border-radius: $circular-radius;
    -gtk-outline-radius: $circular-radius;
  }
}

%needs_attention {
  animation: needs_attention $duration-ripple $ease-out forwards;
  background-repeat: no-repeat;
  background-position: right 3px;
  background-size: 6px 6px;

  &:dir(rtl) { background-position: left 3px; }
}

// all the following is for the +|- buttons on inline toolbars, that way
// should really be deprecated...
.inline-toolbar toolbutton > button { // redefining the button look is
                                      // needed since those are flat...
}

// More inline toolbar buttons
toolbar.inline-toolbar toolbutton {
  // > button.flat { @extend %linked_middle; }

  // &:first-child > button.flat { @extend %linked:first-child; }

  // &:last-child > button.flat { @extend %linked:last-child; }

  // &:only-child > button.flat { @extend %linked:only-child; }
}

%linked_middle {
  border-radius: 0;
  -gtk-outline-radius: $corner-radius;
}

%linked {
  @extend %linked_middle;

  &:first-child {
    border-top-left-radius: $corner-radius;
    border-bottom-left-radius: $corner-radius;
  }

  &:last-child {
    border-top-right-radius: $corner-radius;
    border-bottom-right-radius: $corner-radius;
  }

  &:only-child {
    border-radius: $corner-radius;
  }
}

%linked_vertical_middle {
  border-radius: 0;
  -gtk-outline-radius: $corner-radius;
}

%linked_vertical {
  @extend %linked_vertical_middle;

  &:first-child {
    border-top-left-radius: $corner-radius;
    border-top-right-radius: $corner-radius;
  }

  &:last-child {
    border-bottom-left-radius: $corner-radius;
    border-bottom-right-radius: $corner-radius;
  }

  &:only-child {
    border-radius: $corner-radius;
  }
}

%linked_entry {
  @extend %linked_middle;

  &:first-child {
    border-radius: $corner-radius 0 0 0;
  }

  &:last-child {
    border-radius: 0 $corner-radius 0 0;
  }

  &:only-child {
    border-radius: $corner-radius $corner-radius 0 0;
  }
}

%linked_vertical_entry {
  @extend %linked_vertical_middle;

  &:first-child {
    border-radius: $corner-radius $corner-radius 0 0;
  }

  &:last-child {
    border-radius: 0;
  }

  &:only-child {
    border-radius: $corner-radius $corner-radius 0 0;
  }
}

/* menu buttons */
modelbutton.flat,
.menuitem.button.flat {
  min-height: $menuitem-size;
  padding: 0 8px;
  border-radius: $corner-radius;
  color: inherit;

  @extend %simple_flat_button;

  &:selected { @extend %selected_items; }
}

modelbutton.flat arrow {
  &.left { -gtk-icon-source: -gtk-icontheme("pan-start-symbolic"); }

  &.right { -gtk-icon-source: -gtk-icontheme("pan-end-symbolic"); }
}

button.color {
  min-height: $small-size;
  min-width: $small-size;
  padding: $container-padding;

  colorswatch:only-child {
    // &, overlay { border-radius: 0; }
  }
}


/*********
 * Links *
 *********/
*:link {
  color: $link;

  &:visited { color: $link-visited; }
}

button:link,
button:visited {
  &, &:hover, &:active { @extend *:link; }

  > label { text-decoration-line: underline; }
}

/*****************
 * GtkSpinButton *
 *****************/
spinbutton {
  &:not(.vertical) {
    // in this horizontal configuration, the whole spinbutton
    // behaves as the entry, so we extend the entry styling
    // and nuke the style on the internal entry
    @extend %entry;

    padding: 0;

    entry {
      min-width: $large-size - 8px * 2;
      // reset all the other props since the spinbutton node is styled here
      margin: 0;
      border-image: none;
      border-radius: 0;
      box-shadow: none;
      background-color: transparent;
    }

    button {
      // margin: $container-padding;
      border: solid $container-padding transparent;

      @extend %simple_flat_button;

      @extend %small_button;

      &.up:dir(ltr),
      &.down:dir(rtl) { margin-left: -$container-padding / 2; }

      &.up:dir(rtl),
      &.down:dir(ltr) { margin-right: -$container-padding / 2; }
    }
  }

  // OSD horizontal
  .osd &:not(.vertical) {
  }

  // Vertical
  &.vertical {
    // in the vertical configuration, we treat the spinbutton
    // as a box, and tweak the style of the entry in the middle
    // so that it's linked

    // FIXME: this should not be set at all, but otherwise it gets the wrong
    // color
    &:disabled { color: $text-disabled; }

    &:drop(active) {
      box-shadow: none;
    }

    entry {
      @extend %entry_raised;

      min-height: $medium-size;
      min-width: $large-size;
      padding: 0;
    }

    button {
      min-height: $medium-size;
      min-width: $large-size;
      padding: 0;

      @extend %simple_flat_button;

      &.up { border-radius: $corner-radius $corner-radius 0 0; }

      &.down { border-radius: 0 0 $corner-radius $corner-radius; }
    }
  }

  // OSD vertical
  .osd &.vertical {
  }

  // Misc
  treeview &:not(.vertical) {
    min-height: 0;
    border-style: none;
    border-radius: 0;

    entry {
      min-height: 0;
      padding: 1px 2px;
    }
  }
}


/**************
 * ComboBoxes *
 **************/
combobox {
  arrow {
    -gtk-icon-source: -gtk-icontheme('pan-down-symbolic');
    min-height: 16px;
    min-width: 16px;
  }

  decoration,
  button.combo:checked { transition: none; } // workaround for menuitem selection

  button.combo cellview {
    &:dir(ltr) { margin-left: 8px - ($medium-size - 16px) / 2; }
    &:dir(rtl) { margin-right: 8px - ($medium-size - 16px) / 2; }
  }

  #gtk-combobox-popup-menu {
    padding: 2px 0;

    menuitem {
      min-height: $medium-size - 2px * 2;
      padding: 0 8px;
    }

    // overflow arrows
    > arrow {
      &.top { margin-top: -2px; }

      &.bottom {
        margin-top: 2px * 2;
        margin-bottom: -2px * 3;
      }
    }
  }

  &.linked {
    button:nth-child(2) {
      &:dir(ltr) { @extend %linked_entry:last-child; }
      &:dir(rtl) { @extend %linked_entry:first-child; }
    }
  }

  > .linked > button {
    @extend %linked_middle;

    &:first-child { @extend %linked_entry:first-child; }

    &:last-child { @extend %linked_entry:last-child; }

    &:only-child { @extend %linked_entry:only-child; }
  }

  &:drop(active) { // FIXME: untested
    box-shadow: none;

    // button.combo { @extend %button_basic:drop(active); }
  }
}

// the combo is a composite widget so the way we do button linking doesn't
// work, special case needed. See
// https://bugzilla.gnome.org/show_bug.cgi?id=733979

.linked:not(.vertical) > combobox {
  > box > button.combo { @extend %linked_middle; }

  &:first-child > box > button.combo { @extend %linked_entry:first-child; }

  &:last-child > box > button.combo { @extend %linked_entry:last-child; }

  &:only-child > box > button.combo { @extend %linked_entry:only-child; }
}

.linked.vertical > combobox {
  > box > button.combo { @extend %linked_vertical_middle; }

  &:first-child > box > button.combo { @extend %linked_vertical_entry:first-child; }

  &:last-child > box > button.combo { @extend %linked_vertical_entry:last-child; }

  &:only-child > box > button.combo { @extend %linked_vertical_entry:only-child; }
}

button.combo {
  border-radius: $corner-radius $corner-radius 0 0;
  background-image: none;
  font-weight: inherit;

  @include entry(normal);

  &:hover { box-shadow: inset 0 -1px $text; }

  &:checked { @include entry(focus); }

  &:disabled { @include entry(disabled); }
}


/************
 * Toolbars *
 ************/
toolbar {
  -GtkWidget-window-dragging: true;
  padding: 2px;
  background-color: $background;

  button { @extend %button_basic.flat; }

  // on OSD
  .osd & { background-color: transparent; }

  // stand-alone OSD toolbars
  &.osd {
    transition: $transition-shadow;
    padding: $container-padding;
    border-radius: $corner-radius;
    box-shadow: $shadow-2, inset 0 1px highlight($surface);
    background-color: $surface;

    &:backdrop { box-shadow: $shadow-1, inset 0 1px highlight($surface); }

    &.left,
    &.right,
    &.top,
    &.bottom { border-radius: 0; } // positional classes for `attached` osd toolbars
  }

  // toolbar separators
  &.horizontal > separator { margin: 2px; }
  &.vertical > separator { margin: 2px; }

  &:not(.inline-toolbar):not(.osd) {
    scale,
    entry,
    spinbutton,
    button { margin: 2px; }

    .linked entry,
    .linked spinbutton,
    .linked button {
      &:not(:first-child) { margin-left: 0; }
      &:not(:last-child) { margin-right: 0; }
    }

    spinbutton {
      entry,
      button { margin: 0; }
    }

    switch { margin: 2px + $container-padding 2px; }
  }
}

// searchbar, location-bar & inline-toolbar
.inline-toolbar {
  padding: $container-padding;
  border-style: solid;
  border-width: 0 1px 1px;
  border-color: $border;
  background-color: $base-alt;
}

searchbar > revealer > box,
.location-bar {
  padding: $container-padding;
  border-style: solid;
  border-width: 0 0 1px;
  border-color: $border;
  background-color: $background;
  background-clip: border-box;
}

searchbar > revealer > box {
  // workaround: undo the GtkContainer:border-width and use CSS padding instead
  margin: -6px;
  padding: $container-padding;
}


/***************
 * Header bars *
 ***************/
%titlebar,
headerbar {
  transition: background-color $duration $ease-out, color $duration $ease-out;
  min-height: $large-size;
  padding: 0 $container-padding;
  box-shadow: $shadow-1, inset 0 1px highlight($titlebar);
  background-color: $titlebar;
  color: $titlebar-text;

  &:disabled { color: $titlebar-text-disabled; }

  &:backdrop {
    color: $titlebar-text-secondary;

    &:disabled { color: $titlebar-text-secondary-disabled; }
  }

  .title {
    padding: 0 12px;
    font-weight: bold;
  }

  .subtitle {
    padding: 0 12px;
    font-size: smaller;

    @extend .dim-label;
  }

  entry {
    box-shadow: inset 0 -1px $titlebar-track;
    background-color: $titlebar-fill;
    color: $titlebar-text;

    &:disabled {
      box-shadow: inset 0 -1px $titlebar-divider;
      background-color: $titlebar-fill;
      color: $titlebar-text-disabled;
    }

    image {
      color: $titlebar-text-secondary;

      &:hover, &:active { color: $titlebar-text; }

      &:disabled { color: $titlebar-text-disabled; }
    }
  }

  .linked:not(.vertical) > entry:not(.flat) { border-radius: $corner-radius $corner-radius 0 0; }

  @at-root %titlebar-button, & button:not(.suggested-action):not(.destructive-action) {
    @extend %button_basic.flat;

    border-image: radial-gradient(circle closest-corner at center calc(100% - 1px),
                                  $titlebar-indicator 0%,
                                  transparent 0%)
                                  0 0 0 / 0 0 0px;
    color: $titlebar-text-secondary;

    &:hover, &:active { color: $titlebar-text; }

    &:disabled { color: $titlebar-text-secondary-disabled; }

    &:checked {
      border-image: radial-gradient(circle closest-corner at center calc(100% - 1px),
                                    $titlebar-indicator 100%,
                                    transparent 0%)
                                    0 0 2 / 0 0 2px;
      color: $titlebar-text;

      &:disabled { color: $titlebar-text-disabled; }

      &, &:disabled { background-color: transparent; }
    }

    &:backdrop {
      color: $titlebar-text-disabled;

      &:hover, &:active { color: $titlebar-text-secondary; }

      &:disabled { color: $titlebar-text-secondary-disabled; }

      &:checked {
        color: $titlebar-text-secondary;

        &:disabled { color: $titlebar-text-secondary-disabled; }
      }
    }
  }

  button.suggested-action, button.destructive-action {
    &:disabled {
      background-color: $titlebar-fill;
      color: $titlebar-text-disabled;
    }
  }

  &.selection-mode {
    // 0.00001s was a workaround for https://gitlab.gnome.org/GNOME/gtk/issues/698
    // but let's keep it for backwards compatibility.
    transition: background-color 0.00001s $duration-ripple, color $duration-ripple $ease-out;
    animation: ripple-headerbar $duration-ripple $ease-out;
    box-shadow: $shadow-1, inset 0 1px highlight($primary);
    background-color: $primary;
    color: on($primary);

    &:backdrop {
      color: on($primary, secondary);
    }

    .subtitle:link { color: on($primary); }

    button:not(.suggested-action):not(.destructive-action) {
      border-image: radial-gradient(circle closest-corner at center calc(100% - 1px),
                                    currentColor 0%,
                                    transparent 0%)
                                    0 0 0 / 0 0 0px;
      color: on($primary);

      &:disabled { color: on($primary, disabled); }

      &:checked {
        border-image: radial-gradient(circle closest-corner at center calc(100% - 1px),
                                      currentColor 100%,
                                      transparent 0%)
                                      0 0 2 / 0 0 2px;
        color: on($primary);

        &:disabled { color: on($primary, disabled); }
      }

      &:backdrop {
        color: on($primary, secondary);

        &:disabled { color: on($primary, secondary-disabled); }

        &:checked {
          color: on($primary, secondary);

          &:disabled { color: on($primary, secondary-disabled); }
        }
      }
    }

    .selection-menu {
      padding-left: 16px;
      padding-right: 16px;

      arrow { -GtkArrow-arrow-scaling: 1; }

      .arrow { -gtk-icon-source: -gtk-icontheme('pan-down-symbolic'); }
    }
  }

  // squared corners when the window is maximized, tiled, or fullscreen
  .tiled &,
  .tiled-top &,
  .tiled-right &,
  .tiled-bottom &,
  .tiled-left &,
  .maximized &,
  .fullscreen & {
    border-radius: 0;
    box-shadow: $shadow-1;
  }

  &.default-decoration {
    min-height: $small-size;
    padding: $container-padding;
    box-shadow: inset 0 1px highlight($titlebar);

    .tiled &,
    .maximized &,
    .fullscreen & { box-shadow: none; }

    button.titlebutton {
      min-height: $small-size;
      min-width: $small-size;
      margin: 0;
      padding: 0;
    }

    // workaround for non-animatable buttons
    .background:not(.csd) & button.titlebutton:active { background-size: 1000% 1000%; }
  }

  .solid-csd & {
    &:dir(rtl), &:dir(ltr) { // specificity bump
      // margin-left: -2px;
      // margin-right: -2px;
      // margin-top: -2px;
      // border-radius: 0;
      box-shadow: $shadow-1; // Remove highlight as window managers should have it
    }
  }
}

headerbar {
  // add vertical margins to common widget on the headerbar to avoid them spanning the whole height
  entry,
  spinbutton,
  button {
    margin-top: $container-padding;
    margin-bottom: $container-padding;
  }

  separator.titlebutton {
    margin-top: $large-size / 4;
    margin-bottom: $large-size / 4;
    background-color: $titlebar-divider;
  }

  switch {
    margin-top: ($large-size - 24px) / 2;
    margin-bottom: ($large-size - 24px) / 2;
  }

  // reset button margins of the spinbutton
  spinbutton button {
    margin-top: 0;
    margin-bottom: 0;
  }

  // FIXME: This is a hacky workaround.
  .entry-tag {
    margin-top: 5px;
    margin-bottom: 5px;
  }

  &.titlebar headerbar:not(.titlebar) {
    // Drop the background of non-titlebar nested headerbars. This is needed to
    // work around headerbar sliding animation issues without refactoring
    // Adwaita's support of titlebars and headerbars as it may break
    // applications.
    // See https://gitlab.gnome.org/GNOME/gtk/issues/1264 for more information.
    background-color: transparent;
    box-shadow: none;
  }
}

.background .titlebar {
  border-top-left-radius: $corner-radius;
  border-top-right-radius: $corner-radius;
}

.background.tiled .titlebar,
.background.tiled-top .titlebar,
.background.tiled-right .titlebar,
.background.tiled-bottom .titlebar,
.background.tiled-left .titlebar,
.background.maximized .titlebar,
.background.solid-csd .titlebar {
  border-top-left-radius: 0;
  border-top-right-radius: 0;
}

headerbar { // headerbar border rounding
  window separator:first-child + &, // tackles the paned container case
  window &:first-child { border-top-left-radius: $corner-radius; }

  window &:last-child { border-top-right-radius: $corner-radius; }

  window stack & { // tackles the stacked headerbars case
    &:first-child, &:last-child {
      border-top-left-radius: $corner-radius;
      border-top-right-radius: $corner-radius;
    }
  }

  window.tiled &,
  window.tiled-top &,
  window.tiled-right &,
  window.tiled-bottom &,
  window.tiled-left &,
  window.maximized &,
  window.fullscreen &,
  window.solid-csd & {
    &,
    &:first-child,
    &:last-child,
    &:only-child {
      border-top-left-radius: 0;
      border-top-right-radius: 0;
    }
  }
}

.titlebar:not(headerbar) {
  window.csd > & {
    // in csd we assume every titlebar is a headerbar so reset anything, this is needed for split toolbars cases
    padding: 0;
    background-color: transparent;
    background-image: none;
    border-style: none;
    box-shadow: none;
  }

  > separator {
    background-color: $titlebar;
    background-image: image($border);
  }

  @extend %titlebar;
}

// Development versions of apps to use a differently styled headerbar
window.devel headerbar.titlebar:not(.selection-mode) {
}


/************
 * Pathbars *
 ************/
%pathbar_button,
.path-bar button {
  padding-left: ($medium-size - 24px) / 2;
  padding-right: ($medium-size - 24px) / 2;

  label:not(:only-child) {
    &:first-child { margin-left: 4px; }

    &:last-child { margin-right: 4px; }
  }

  &.slider-button {
    padding-left: (24px - 16px) / 2;
    padding-right: (24px - 16px) / 2;
  }

  :not(headerbar) & {
    @extend %flat_button;

    border-image: radial-gradient(circle closest-corner at center calc(100% - 1px),
                                  $primary 0%,
                                  transparent 0%)
                                  0 0 0 / 0 0 0px;
    border-radius: $corner-radius;

    &:checked {
      border-image: radial-gradient(circle closest-corner at center calc(100% - 1px),
                                    $primary 100%,
                                    transparent 0%)
                                    0 0 2 / 0 0 2px;

      &, &:disabled { background-color: transparent; }
    }
  }
}


/**************
 * Tree Views *
 **************/
treeview.view {
  @at-root * {
    -GtkTreeView-horizontal-separator: 4;
    -GtkTreeView-grid-line-width: 1;
    -GtkTreeView-grid-line-pattern: '';
    -GtkTreeView-tree-line-width: 1;
    -GtkTreeView-tree-line-pattern: '';
    -GtkTreeView-expander-size: 16;
  }

  border-left-color: $track; // this is actually the tree lines color,
  border-top-color: $border; // while this is the grid lines color, better then nothing

  // FIXME: Avoid transparency background-color being slightly darker
  &:selected {
    background-color: $base;
    background-image: image($overlay-selected);
  }

  rubberband { @extend rubberband; } // to avoid borders being overridden by the previously set props

  &:hover, &:selected { border-radius: 0; }

  &.separator {
    min-height: 1px + 2px * 2;
    color: $border;
  }

  &:drop(active) {
    border-style: solid none;
    border-width: 1px;
    border-color: $primary;

    &.after { border-top-style: none; }

    &.before { border-bottom-style: none; }
  }

  &.expander {
    -gtk-icon-source: -gtk-icontheme('pan-down-symbolic');
    -gtk-icon-transform: rotate(-90deg);

    &:dir(rtl) { -gtk-icon-transform: rotate(90deg); }

    &:checked { -gtk-icon-transform: unset; }

    color: $text-secondary;

    &:hover, &:active { color: $text; }

    &:disabled { color: $text-secondary-disabled; }
  }

  &.progressbar { // progress bar in treeviews
    border-bottom: $bar-size solid $primary;
    box-shadow: none;
    background-color: transparent;
    background-image: none;

    &:selected:hover { box-shadow: none; }
  }

  &.trough { // progress bar trough in treeviews
    border-bottom: $bar-size solid $divider;
    box-shadow: none;
    background-color: transparent;
    background-image: none;

    &:selected:hover { box-shadow: none; }
  }

  header {
    button {
      @extend row.activatable;

      padding: 2px 6px;
      border-style: none solid solid none;
      border-width: 1px;
      border-color: $border;
      border-radius: 0;
      background-clip: border-box;

      &:not(:hover):not(:active) { color: $text-secondary; }

      &, &:hover, &:active { box-shadow: none; }

      &, &:disabled { background-color: $base; }

      &:last-child { border-right-style: none; }
    }
  }

  button.dnd,
  header.button.dnd { // for treeview-like derive widgets
    padding: 2px 6px;
    border-style: none solid solid;
    border-width: 1px;
    border-color: $border;
    border-radius: 0;
    box-shadow: none;
    background-color: $base;
    background-clip: border-box;
    color: $primary;
  }

  acceleditor > label { background-color: $primary; } // see tests/testaccel to test
}


/*********
 * Menus *
 *********/
menubar,
.menubar {
  -GtkWidget-window-dragging: true;
  padding: 0;
  // box-shadow: inset 0 -1px $border;
  background-color: $titlebar;

  > menuitem {
    transition: $transition;
    min-height: 20px;
    padding: 4px 8px;
    color: $titlebar-text-secondary;

    &:hover { // Seems like it :hover even with keyboard focus
      transition: none;
      background-color: $titlebar-divider;
      color: $titlebar-text;
    }

    &:disabled { color: $titlebar-text-secondary-disabled; }

    label:disabled { color: inherit; } // to inherit the above color
  }
}

// Needed to make the border-radius of menus work
// otherwise the background bleeds out of the menu edges
.background.popup { background-color: transparent; }

menu,
.menu,
.context-menu {
  margin: 4px 0; // See https://bugzilla.gnome.org/show_bug.cgi?id=591258
  padding: 4px 0;
  box-shadow: inset 0 1px highlight($surface);
  background-color: $surface;
  border: 1px solid $border; // adds borders in a non composited env

  .csd & {
    border: none; // axes borders in a composited env
    border-radius: $corner-radius;
  }

  menuitem {
    transition: background-color $duration $ease-out;
    min-height: 20px;
    min-width: 40px;
    padding: 4px 8px;
    font: initial;
    text-shadow: none;

    &:hover {
      transition: none;
      background-color: $divider;
    }

    &:disabled { color: $text-disabled; }

    // submenu indicators
    arrow {
      min-height: 16px;
      min-width: 16px;

      &:dir(ltr) {
        -gtk-icon-source: -gtk-icontheme('pan-end-symbolic');
        margin-left: 8px;
      }

      &:dir(rtl) {
        -gtk-icon-source:-gtk-icontheme('pan-end-symbolic-rtl');
        margin-right: 8px;
      }
    }

    // avoids labels color being overridden, see
    // https://bugzilla.gnome.org/show_bug.cgi?id=767058
    label { &:dir(rtl), &:dir(ltr) { color: inherit; }}
  }

  // overflow arrows
  > arrow {
    min-height: 16px;
    min-width: 16px;
    padding: 4px;
    background-color: $surface;
    color: $text-secondary;

    &.top {
      margin-top: -4px;
      border-bottom: 1px solid $border;
      border-radius: $corner-radius $corner-radius 0 0;
      -gtk-icon-source: -gtk-icontheme('pan-up-symbolic');
    }

    &.bottom {
      margin-top: 4px * 2;
      margin-bottom: -4px * 3;
      border-top: 1px solid $border;
      border-radius: 0 0 $corner-radius $corner-radius;
      -gtk-icon-source: -gtk-icontheme('pan-down-symbolic');
    }

    &:hover {
      background-image: image($divider);
      color: $text;
    }

    &:disabled {
      border-color: transparent;
      background-color: transparent;
      color: transparent;
      // color: $text-secondary-disabled;
    }
  }

  separator { margin: 4px 0; }
}

menuitem {
  accelerator { color: $text-secondary; }

  &:disabled accelerator { color: $text-secondary-disabled; }
}

// FIXME: THIS IS A REALLY UGLY WORKAROUND!
// Electron/Atom render all translucent colors in opaque colors.
// It's a very critical issue for this theme and should be fixed by upstream...
.popup:not(.csd) menu {
  menuitem {
    color: $solid-text;

    &:hover { background-color: $solid-divider; }

    &:disabled { color: $solid-text-disabled; } // separator/border also use this color.
  }

  // FIXME: not working this
  accelerator { color: $solid-text-secondary; }
}


/************
 * Popovers *
 ************/
popover.background {
  transition: $transition-shadow;
  padding: 2px;
  box-shadow: $shadow-2; // TODO: this should really have a highlight
  background-color: $surface;

  &:backdrop { box-shadow: $shadow-1; }

  &, .csd & {
    border-style: solid;
    border-width: 1px;
    border-color: rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.2) rgba(0, 0, 0, 0.3);
    border-radius: $corner-radius + 1px;
  }

  > stack { margin: -4px; } // remove extra padding from menu style popovers

  > toolbar { margin: -2px; }

  > list,
  > .view,
  > toolbar {
    border-style: none;
    box-shadow: none;
    background-color: transparent;
  }

  // FIXME: Use the popover color instead of transparent as a workaround for .view
  list,
  .view:not(:selected),
  toolbar { background-color: $surface; }

  // &.touch-selection,
  // &.magnifier,
  // &.osd { @extend %osd; }

  // button:not(.suggested-action):not(.destructive-action) { @extend %button_basic.flat; }

  &.menu button,
  button.model {
    @extend %simple_flat_button;

    min-height: 32px;
    padding: 0 8px;
    border-radius: $corner-radius;

    &:checked { @extend %selected_items; }
  }

  separator { margin: 4px 0; }

  list separator { margin: 0; }
}

/*************
 * Notebooks *
 *************/
notebook {
  frame > paned > & > header,
  &.frame > header { background-color: $base-alt; }

  &:focus tab:checked {
    box-shadow: inset 0 0 0 9999px rgba($primary, 0.12);
    outline: none;
  }

  > header {
    border-width: 1px;
    border-color: $border;
    background-color: $background;
    background-clip: border-box;

    &.top {
      border-bottom-style: solid;

      > tabs {
        margin-bottom: -1px;

        > tab {
          border-image: linear-gradient(to top, transparent 2px, transparent 2px) 2 / 0 0 2px;

          &:checked { border-image-source: linear-gradient(to top, $primary 2px, $border 2px); }

          &.reorderable-page { border-image-width: 0 1px 2px; }
        }
      }
    }

    &.bottom {
      border-top-style: solid;

      > tabs {
        margin-top: -1px;

        > tab {
          border-image: linear-gradient(to bottom, transparent 2px, transparent 2px) 2 / 2px 0 0;

          &:checked { border-image-source: linear-gradient(to bottom, $primary 2px, $border 2px); }

          &.reorderable-page { border-image-width: 2px 1px 0; }
        }
      }
    }

    &.left {
      border-right-style: solid;

      > tabs {
        margin-right: -1px;

        > tab {
          border-image: linear-gradient(to left, transparent 2px, transparent 2px) 2 / 0 2px 0 0;

          &:checked { border-image-source: linear-gradient(to left, $primary 2px, $border 2px); }

          &.reorderable-page { border-image-width: 1px 2px 1px 0; }
        }
      }
    }

    &.right {
      border-left-style: solid;

      > tabs {
        margin-left: -1px;

        > tab {
          border-image: linear-gradient(to right, transparent 2px, transparent 2px) 2 / 0 0 0 2px;

          &:checked { border-image-source: linear-gradient(to right, $primary 2px, $border 2px); }

          &.reorderable-page { border-image-width: 1px 0 1px 2px; }
        }
      }
    }

    &.top > tabs > arrow {
      @extend %notebook_vert_arrows;

      border-top-style: none;
    }

    &.bottom > tabs > arrow {
      @extend %notebook_vert_arrows;

      border-bottom-style: none;
    }

    @at-root %notebook_vert_arrows {
      padding-left: 4px;
      padding-right: 4px;

      &.down {
        margin-left: -8px;
        -gtk-icon-source: -gtk-icontheme('pan-start-symbolic');
      }

      &.up {
        margin-right: -8px;
        -gtk-icon-source: -gtk-icontheme('pan-end-symbolic');
      }
    }

    &.left > tabs > arrow {
      @extend %notebook_horz_arrows;

      border-left-style: none;
    }

    &.right > tabs > arrow {
      @extend %notebook_horz_arrows;

      border-right-style: none;
    }

    @at-root %notebook_horz_arrows {
      padding-top: 4px;
      padding-bottom: 4px;

      &.down {
        margin-top: -8px;
        -gtk-icon-source: -gtk-icontheme('pan-up-symbolic');
      }

      &.up {
        margin-bottom: -8px;
        -gtk-icon-source: -gtk-icontheme('pan-down-symbolic');
      }
    }

    > tabs > arrow {
      @extend %simple_flat_button;

      min-height: 16px;
      min-width: 16px;
      border-radius: 0;
    }

    tab {
      transition: $transition,
                  background-size 0,
                  background-image 0;
      min-height: $small-size;
      min-width: $small-size;
      padding: $container-padding 12px;

      outline-offset: -6px;

      border-width: 1px;         // for reorderable tabs
      border-color: transparent; //

      background-image: radial-gradient(circle farthest-corner at center,
                                        $primary 10%,
                                        transparent 0%);
      background-repeat: no-repeat;
      background-position: center;
      background-size: 0% 0%;
      background-clip: border-box;

      color: $text-secondary;
      font-weight: 500;

      &:hover {
        background-color: $overlay-hover;
        color: $text;
      }

      &:disabled { color: $text-secondary-disabled; }

      &:checked {
        transition: $transition,
                    background-size $duration-ripple $ease-out,
                    background-image $duration-ripple + $duration-ripple-aftermath $ease-out;
        background-color: transparent;
        background-image: radial-gradient(circle farthest-corner at center,
                                          transparent 10%,
                                          transparent 0%);
        background-size: 1000% 1000%;
        background-clip: padding-box;
        color: $text;

        &:disabled { color: $text-disabled; }

        &.reorderable-page {
          border-color: $border;
          background-color: $base;
        }
      }

      // colors the button like the label, overridden otherwise
      button.flat {
        @extend %small_button;

        &:last-child {
          margin-left: $container-padding;
          margin-right: $container-padding - 12px;
        }

        &:first-child {
          margin-left: $container-padding - 12px;
          margin-right: $container-padding;
        }
      }
    }

    &.top,
    &.bottom {
      tabs {
        padding-left: 8px;
        padding-right: 8px;

        &:not(:only-child) {
          &:first-child { margin-left: 0; }

          &:last-child { margin-right: 0; }
        }

        tab.reorderable-page { border-style: none solid; }
      }
    }

    &.left,
    &.right {
      tabs {
        padding-top: 8px;
        padding-bottom: 8px;

        &:not(:only-child) {
          &:first-child { margin-top: 0; }

          &:last-child { margin-bottom: 0; }
        }

        tab.reorderable-page { border-style: solid none; }
      }
    }
  }

  > stack:not(:only-child) { // the :not(:only-child) is for "hidden" notebooks
    background-color: $base;
  }
}


/**************
 * Scrollbars *
 **************/
scrollbar {
  $_slider_min_length: 24px;

  // disable steppers
  @at-root * {
    -GtkScrollbar-has-backward-stepper: false;
    -GtkScrollbar-has-forward-stepper: false;
  }

  transition: $transition;
  background-color: $base;
  background-clip: $background-clip-extra;

  // scrollbar border
  &.top { border-bottom: 1px solid $border; }
  &.bottom { border-top: 1px solid $border; }
  &.left { border-right: 1px solid $border; }
  &.right { border-left: 1px solid $border; }

  // slider
  slider {
    transition: $transition, margin 0, border-width 0;
    min-width: 8px;
    min-height: 8px;
    border: 4px solid transparent;
    border-radius: $circular-radius;
    background-clip: padding-box;
    background-color: $text-disabled;

    &:hover { background-color: $text-secondary; }

    &:active { background-color: $text; }

    &:disabled { background-color: $text-secondary-disabled; }
  }

  &.fine-tune {
    slider {
      transition: $transition, margin 0, border-width 0, min-width 0, min-height 0;
      min-width: 4px;
      min-height: 4px;
    }

    &.horizontal slider { margin: 2px 0; }

    &.vertical slider { margin: 0 2px; }
  }

  &.overlay-indicator {
    &:not(.dragging):not(.hovering) {
      border-color: transparent;
      background-color: transparent;

      slider {
        min-width: 4px;
        min-height: 4px;
        margin: 4px - 1px;
        border: 1px solid rgba($base, 0.3);
      }

      button {
        min-width: 4px;
        min-height: 4px;
        margin: 4px - 1px;
        border: 1px solid rgba($base, 0.3);
        border-radius: $circular-radius;
        background-color: $text-disabled;
        background-clip: padding-box;
        -gtk-icon-source: none;

        &:disabled { background-color: $text-secondary-disabled; }
      }

      &.horizontal {
        slider { min-width: $_slider_min_length; }

        button { min-width: 8px; }
      }

      &.vertical {
        slider { min-height: $_slider_min_length; }

        button { min-height: 8px; }
      }
    }

    &.dragging,
    &.hovering { background-color: rgba($base, 0.9); }
  }

  &.horizontal slider { min-width: $_slider_min_length; }

  &.vertical slider { min-height: $_slider_min_length; }

  // button styling
  button {
    @extend %simple_flat_button;

    min-width: 16px;
    min-height: 16px;
    padding: 0;
    border-radius: 0;
  }

  // button icons
  &.vertical {
    button {
      &.down { -gtk-icon-source: -gtk-icontheme('pan-down-symbolic'); }

      &.up { -gtk-icon-source: -gtk-icontheme('pan-up-symbolic'); }
    }
  }

  &.horizontal {
    button {
      &.down { -gtk-icon-source: -gtk-icontheme('pan-end-symbolic'); }

      &.up { -gtk-icon-source: -gtk-icontheme('pan-start-symbolic'); }
    }
  }
}


/**********
 * Switch *
 **********/
switch {
  transition: all $duration $ease-out;
  margin: $container-padding 0;
  padding: 0 2px;
  border: 5px solid transparent;
  border-radius: $circular-radius;
  background-color: $track;
  background-clip: padding-box;
  font-size: 0;

  &:checked { background-color: rgba($primary, 0.5); }

  &:disabled { opacity: 0.5; }

  // hide on/off icons for >=3.24.5
  image {
    margin: -8px;
    -gtk-icon-transform: scale(0);
  }

  slider {
    transition: all $duration $ease-out;
    min-width: 20px;
    min-height: 20px;
    margin: -3px -2px;
    border-radius: $circular-radius;
    outline: none;
    box-shadow: 0 0 0 10px transparent, $shadow-1;
    background-color: $surface;
  }

  &:hover slider { box-shadow: 0 0 0 10px $overlay-hover, $shadow-1; }

  &:focus slider { box-shadow: 0 0 0 10px $overlay-focus, $shadow-1; }

  &:focus:hover slider { box-shadow: 0 0 0 10px $overlay-focus-hover, $shadow-1; }

  &:checked slider {
    background-color: $primary;
    color: $primary;
  }

  row:selected & {
  }
}


/*************************
 * Check and Radio items *
 *************************/
// draw regular check and radio items using our PNG assets
// all assets are rendered from assets.svg. never add pngs directly

// selection-mode
.view.content-view.check:not(list),
.content-view .tile check:not(list) {
  min-height: 40px;
  min-width: 40px;
  margin: 0;
  padding: 0;
  box-shadow: none;
  background-color: transparent;
  background-image: none;
  -gtk-icon-shadow: $shadow-1;

  &:hover, &:active { -gtk-icon-shadow: $shadow-2; }

  @each $s, $as in ('', '-unchecked'),
                   (':checked', '-checked') {
    &#{$s} {
      -gtk-icon-source: -gtk-scaled(url("assets/selectionmode-checkbox#{$as}#{$asset-suffix}.png"),
                                    url("assets/selectionmode-checkbox#{$as}#{$asset-suffix}@2.png"));
    }
  }
}

checkbutton,
radiobutton {
  outline: none;
}

checkbutton.text-button,
radiobutton.text-button {
  // this is for a nice focus on check and radios text
  padding: 2px;

  label:not(:only-child) { margin: 0 4px; }
}

$check_radio_size: 40px;

check,
radio {
  min-height: 24px;
  min-width: 24px;
  margin: -($check_radio_size - 24px) / 2;
  padding: ($check_radio_size - 24px) / 2;

  @extend %simple_flat_button;

  @extend %circular_button;

  &:hover { box-shadow: inset 0 0 0 9999px $overlay-hover; }

  &:focus { box-shadow: inset 0 0 0 9999px $overlay-focus; }

  &:focus:hover { box-shadow: inset 0 0 0 9999px $overlay-focus-hover; }

  &:checked, &:indeterminate {
    color: $primary;

    &:disabled { color: $text-secondary-disabled; }
  }

  // &:only-child { margin: -12px; }

  popover modelbutton.flat & {
    &, &:hover, &:focus, &:focus:hover, &:active, &:disabled {
      transition: none; // FIXME: this is a workaround for a popover check/radio long transition issue
      box-shadow: none;
      background-image: none;
    }

    &:not(:checked):not(:indeterminate):not(:disabled) { color: $text-secondary; }

    &.left:dir(rtl) {
      margin-left: -12px;
      margin-right: -4px;
    }

    &.right:dir(ltr) {
      margin-left: -4px;
      margin-right: -12px;
    }
  }

  menu menuitem & {
    transition: none;
    margin: 0; // this is a workaround for a menu check/radio size allocation issue
    padding: 0;

    &:dir(ltr) { margin-right: 8px; }

    &:dir(rtl) { margin-left: 8px; }

    &:not(:checked):not(:indeterminate):not(:disabled) { color: $text-secondary; }

    &, &:hover, &:disabled {
      box-shadow: none;
      // color: inherit;
    }
  }
}

%check,
check {
  -gtk-icon-source: -gtk-recolor(url("assets/scalable/checkbox-unchecked-symbolic.svg"));

  &:checked { -gtk-icon-source: -gtk-recolor(url("assets/scalable/checkbox-checked-symbolic.svg")); }

  &:indeterminate { -gtk-icon-source: -gtk-recolor(url("assets/scalable/checkbox-mixed-symbolic.svg")); }
}

%radio,
radio {
  -gtk-icon-source: -gtk-recolor(url("assets/scalable/radio-unchecked-symbolic.svg"));

  // &:checked { -gtk-icon-source: -gtk-recolor(url("assets/scalable/radio-checked-symbolic.svg")); }

  &:indeterminate { -gtk-icon-source: -gtk-recolor(url("assets/scalable/radio-mixed-symbolic.svg")); }

  border-image-slice: $check_radio_size / 2px;
  border-image-width: $check_radio_size / 2;

  $radio_indicator: 10px / $check_radio_size / 2;

  & {
    border-image-source: -gtk-gradient(radial,
                                       center center, 0,
                                       center center, 0.001,
                                       to($primary),
                                       to(transparent));
  }

  &:checked:not(:indeterminate) {
    border-image-source: -gtk-gradient(radial,
                                       center center, 0,
                                       center center, $radio_indicator,
                                       to($primary),
                                       to(transparent));
  }

  &:checked:not(:indeterminate):disabled {
    border-image-source: -gtk-gradient(radial,
                                       center center, 0,
                                       center center, $radio_indicator,
                                       to($text-secondary-disabled),
                                       to(transparent));
  }
}

%small_check,
menu menuitem check {
  & {
    min-height: 16px;
    min-width: 16px;
    border-radius: $corner-radius;
    -gtk-outline-radius: $corner-radius;
    -gtk-icon-source: -gtk-recolor(url("assets/scalable/small-checkbox-unchecked-symbolic.svg"));
  }

  &:checked { -gtk-icon-source: -gtk-recolor(url("assets/scalable/small-checkbox-checked-symbolic.svg")); }

  &:indeterminate { -gtk-icon-source: -gtk-recolor(url("assets/scalable/small-checkbox-mixed-symbolic.svg")); }
}

%small_radio,
menu menuitem radio {
  & {
    min-height: 16px;
    min-width: 16px;
    border-image: none;
    -gtk-icon-source: -gtk-recolor(url("assets/scalable/small-radio-unchecked-symbolic.svg"));
  }

  &:checked { -gtk-icon-source: -gtk-recolor(url("assets/scalable/small-radio-checked-symbolic.svg")); }

  &:indeterminate { -gtk-icon-source: -gtk-recolor(url("assets/scalable/small-radio-mixed-symbolic.svg")); }
}

// ANIMATION:
// this is made with those pretty convoluted transitions, since checks and radios have to animate only on state changes,
// the transformation is set on the active state and it get reset on the checked state.
// radio:not(:checked):active { -gtk-icon-transform: scale(0); }

treeview.view check,
treeview.view radio {
  padding: 0;

  &:hover, &:selected {
    box-shadow: none;
    background-color: transparent;
  }

  & {
    color: $text-secondary;

    &:hover, &:active { color: $text; }

    &:disabled { color: $text-secondary-disabled; }

    &:checked, &:indeterminate { color: $primary; }

    &:checked:disabled, &:indeterminate:disabled { color: $text-secondary-disabled; }
  }
}

treeview.view radio:checked {
  -gtk-icon-source: -gtk-recolor(url("assets/scalable/radio-checked-symbolic.svg"));
  border-image: none;
}


/************
 * GtkScale *
 ************/
scale {
  // sizing
  $_marks_length: 8px;
  $_marks_distance: 7px;

  $trough_size: 2px;
  $finetune_trough_size: 4px;

  $slider_size: 32px;

  $slider_margin: -($slider_size - $trough_size) / 2;
  $finetune_slider_margin: -($slider_size - $finetune_trough_size) / 2;

  $color_slider_margin: -($slider_size) * 3 / 4;
  $color_marks_slider_margin: -($slider_size - 16px) - $color_slider_margin;

  min-height: $trough_size;
  min-width: $trough_size;

  &.horizontal { padding: ($medium-size - $trough_size) / 2 12px; }

  &.vertical { padding: 12px ($medium-size - $trough_size) / 2; }

  // the slider is inside the trough, so to have make it bigger there's a negative margin
  slider {
    min-height: $slider_size;
    min-width: $slider_size;
    margin: $slider_margin;
  }

  // click-and-hold the slider to activate
  &.fine-tune {
    &.horizontal {
      min-height: $finetune_trough_size;
      padding-top: ($medium-size - $finetune_trough_size) / 2;
      padding-bottom: ($medium-size - $finetune_trough_size) / 2;
    }

    &.vertical {
      min-width: $finetune_trough_size;
      padding-left: ($medium-size - $finetune_trough_size) / 2;
      padding-right: ($medium-size - $finetune_trough_size) / 2;
    }

    // to make the trough grow in fine-tune mode
    slider { margin: $finetune_slider_margin; }
  }

  // the backing bit
  trough {
    transition: background-color $duration $ease-out;
    outline: none;
    background-color: $track;

    &:disabled { background-color: $divider; }
  }

  // the colored part of the backing bit
  highlight {
    transition: background-color $duration $ease-out;
    background-color: $primary;

    &:disabled { background-color: transparent; }
  }

  // this is another differently styled part of the backing bit, the most relevant use case is for example
  // in media player to indicate how much video stream as been cached
  fill {
    transition: background-color $duration $ease-out;
    background-color: $track;

    &:disabled { background-color: transparent; }
  }

  slider {
    transition: background-color $duration $ease-out,
                background-size $duration-ripple-aftermath $ease-out,
                background-image $duration-ripple-aftermath-opacity $ease-out;
    background-repeat: no-repeat;
    background-position: center;
    background-size: auto, 1000% 1000%;
    border-radius: 50%;
    color: transparent;

    @each $s, $as in ('', ''),
                     (':disabled', '-disabled') {
      &#{$s} {
        $_url: 'assets/scale-slider#{$as}#{$asset-suffix}';

        background-image: -gtk-scaled(url('#{$_url}.png'), url('#{$_url}@2.png')),
                          radial-gradient(circle farthest-corner at center,
                                          currentColor 10%,
                                          transparent 0%);
      }
    }

    &:hover { background-color: rgba($primary, 0.08); }

    &:focus { background-color: rgba($primary, 0.12); }

    &:focus:hover { background-color: rgba($primary, 0.16); }

    &:active {
      transition: background-color $duration $ease-out,
                  background-size 0,
                  background-image 0;
      animation: ripple-slider $duration-ripple $ease-out forwards;
      background-size: auto, 0% 0%;
      background-color: rgba($primary, 0.08);
      color: rgba($primary, 0.12);
    }
  }

  marks label,
  value { color: $text-secondary; }

  marks {
    color: $track;

    @each $marks_class, $marks_pos, $marks_margin in (top, top, bottom),
                                                     (bottom, bottom, top),
                                                     (left, left, right),
                                                     (right, right, left) {
      &.#{$marks_class} {
        margin-#{$marks_margin}: $_marks_distance;
        margin-#{$marks_pos}: -($_marks_distance + $_marks_length);
      }
    }
  }

  &.fine-tune marks {
    @each $marks_class, $marks_pos, $marks_margin in (top, top, bottom),
                                                     (bottom, bottom, top),
                                                     (left, left, right),
                                                     (right, right, left) {
      &.#{$marks_class} {
        margin-#{$marks_margin}: $_marks_distance - 1px;
        margin-#{$marks_pos}: -($_marks_distance + $_marks_length - 1px);
      }
    }
  }

  &.horizontal {
    indicator {
      min-height: $_marks_length;
      min-width: 1px;
    }
  }

  &.vertical {
    indicator {
      min-height: 1px;
      min-width: $_marks_length;
    }
  }

  // *WARNING* scale with marks madness following

  @each $dir_class, $dir_infix in ('horizontal', 'horz'),
                                  ('vertical', 'vert') {
    @each $marks_infix, $marks_class in ('marks-before', 'marks-before:not(.marks-after)'),
                                        ('marks-after', 'marks-after:not(.marks-before)') {
      &.#{$dir_class}.#{$marks_class} {
        slider {
          @each $state, $state_infix in ('', ''),
                                        (':disabled', '-disabled') {
            &#{$state} {
              $_scale_asset: 'assets/scale-#{$dir_infix}-#{$marks_infix}-slider#{$state_infix}#{$asset-suffix}';

              background-image: -gtk-scaled(url('#{$_scale_asset}.png'), url('#{$_scale_asset}@2.png')),
                                radial-gradient(circle farthest-corner at center,
                                                currentColor 10%,
                                                transparent 0%);
            }
          }
        }
      }
    }
  }

  &.color {
    min-height: 0;
    min-width: 0;

    &.horizontal {
      padding: 0 0 12px 0;

      slider {
        &:dir(ltr), &:dir(rtl) { // specificity bump
          margin-bottom: $color_slider_margin;
          margin-top: $color_marks_slider_margin;
        }
      }
    }

    &.vertical {
      &:dir(ltr) {
        padding: 0 0 0 12px;

        slider {
          margin-left: $color_slider_margin;
          margin-right: $color_marks_slider_margin;
        }
      }

      &:dir(rtl) {
        padding: 0 12px 0 0;

        slider {
          margin-right: $color_slider_margin;
          margin-left: $color_marks_slider_margin;
        }
      }
    }
  }
}


/*****************
 * Progress bars *
 *****************/
progressbar {
  // sizing
  &.horizontal {
    trough,
    progress { min-height: $bar-size; }
  }

  &.vertical {
    trough,
    progress { min-width: $bar-size; }
  }

  // FIXME: insensitive state missing and some other state should be set probably
  color: $text-secondary;
  font-size: smaller;

  trough { background-color: $divider; }

  progress { background-color: $primary; }

  &.osd { // progressbar.osd used for epiphany page loading progress
    // min-width: $bar-size;
    // min-height: $bar-size;
    // background-color: transparent;

    // trough { background-color: transparent; }

    // progress { background-color: $primary; }
  }

  trough.empty progress { all: unset; } // makes the progress indicator disappear, when the fraction is 0
}


/*************
 * Level Bar *
 *************/
levelbar {
  &.horizontal {
    block { min-height: $bar-size; }

    &.discrete block {
      min-width: $medium-size;

      &:not(:last-child) { margin-right: 2px; }
    }
  }

  &.vertical {
    block { min-width: $bar-size; }

    &.discrete block {
      min-height: $medium-size;

      &:not(:last-child) { margin-bottom: 2px; }
    }
  }

  // imitate the entry style
  trough {
    // padding: 2px;
    // border-radius: $corner-radius;
    // box-shadow: $shadow-1;
    // background-color: $base;

    // &:disabled { background-color: $base-alt; }
  }

  block {
    &.low { background-color: $warning; }

    &.high,
    &:not(.empty) { background-color: $primary; }

    &.full { background-color: $success; }

    &.empty { background-color: $divider; }
  }
}


/****************
 * Print dialog *
*****************/
printdialog {
  paper {
    padding: 0;
    border: 1px solid $border;
    background-color: $base;
    color: $text;
  }

  .dialog-action-box { margin: 12px; }
}


/**********
 * Frames *
 **********/
frame > border,
.frame {
  margin: 0;
  padding: 0;
  border: 1px solid $border;
  border-radius: 0;
  box-shadow: none;

  &.flat { border-style: none; }
}

frame.flat > border { @extend .frame.flat; } // for backward compatibility

actionbar > revealer > box {
  padding: $container-padding;
  border-top: 1px solid $border;

  button:not(.suggested-action):not(.destructive-action):not(.server-list-button) { @extend %button_basic.flat; }
}

scrolledwindow {
  viewport.frame { // avoid double borders when viewport inside scrolled window
    border-style: none;
  }

  // This is used when content is touch-dragged past boundaries.
  // draws a box on top of the content, the size changes programmatically.
  @at-root overshoot {
    &.top { @include overshoot(top); }

    &.bottom { @include overshoot(bottom); }

    &.left { @include overshoot(left); }

    &.right { @include overshoot(right); }
  }

  // Overflow indication, works similarly to the overshoot, the size if fixed tho.
  @at-root undershoot {
    &.top { @include undershoot(top); }

    &.bottom { @include undershoot(bottom); }

    &.left { @include undershoot(left); }

    &.right { @include undershoot(right); }
  }

  @at-root junction { // the small square between two scrollbars
    border-style: solid none none solid;
    border-width: 1px;
    border-color: $border;
    background-color: $base;

    &:dir(rtl) { border-style: solid solid none none; }
  }
}

// vbox and hbox separators
separator {
  min-width: 1px;
  min-height: 1px;
  background-color: $border;
}

%hide_separators {
  min-width: 0;
  min-height: 0;
  background-color: transparent;
}


/*********
 * Lists *
 *********/
list {
  border-color: $border;
  background-color: $base;

  row { padding: 2px; }
}

row {
  &.activatable {
    transition: $transition,
                background-size $duration-ripple-aftermath $ease-out,
                background-image $duration-ripple-aftermath-opacity $ease-out;
    box-shadow: inset 0 0 0 9999px transparent;
    background-image: radial-gradient(circle farthest-corner at center,
                                      transparent 10%,
                                      transparent 0%);
    background-repeat: no-repeat;
    background-position: center;
    background-size: 1000% 1000%;

    &:hover {
      transition: $transition,
                  box-shadow 0,
                  background-size $duration-ripple-aftermath $ease-out,
                  background-image $duration-ripple-aftermath-opacity $ease-out;
      box-shadow: inset 0 0 0 9999px $overlay-hover;
    }

    &.has-open-popup, // this is for indicathing which row generated a popover see https://bugzilla.gnome.org/show_bug.cgi?id=754411
    &:active {
      transition: $transition,
                  background-size 0,
                  background-image 0;
      animation: ripple $duration-ripple $ease-out forwards;
      box-shadow: inset 0 0 0 9999px $overlay-hover;
      background-image: radial-gradient(circle farthest-corner at center,
                                        $overlay-active 10%,
                                        transparent 0%);
      background-size: 0% 0%;
    }
  }

  &:selected {
    @extend %selected_items;
    color: $primary; // for overlays

    image,
    label { color: $text; }

    button image,
    button label { color: inherit; }

    &:disabled {
      image,
      label { color: $text-disabled; }
    }
  }
}


/*********************
 * App Notifications *
 *********************/
.app-notification {
  // @extend %osd;

  @extend toolbar.osd;

  margin: 8px;

  button { @extend %button_basic.flat; }

  &.frame,
  border { border-style: none; }
}


/*************
 * Expanders *
 *************/
expander {
  title > arrow {
    transition: all $duration $ease-out;
    min-width: 16px;
    min-height: 16px;
    -gtk-icon-source: -gtk-icontheme('pan-down-symbolic');
    -gtk-icon-transform: rotate(-90deg);

    &:dir(rtl) { -gtk-icon-transform: rotate(90deg); }

    &:checked { -gtk-icon-transform: unset; }

    color: $text-secondary;

    &:hover, &:active { color: $text; }

    &:disabled { color: $text-secondary-disabled; }
  }
}


/************
 * Calendar *
 ************/
calendar {
  padding: 1px;
  border: 1px solid $border;
  color: $text;

  &:disabled { color: $text-disabled; }

  &:selected {
    @extend %selected_items;

    border-radius: $corner-radius + 1px;
  }

  &.header {
    border-style: none none solid;
    border-radius: 0;
  }

  &.button { @extend %simple_flat_button; }

  &.highlight {
    color: $text-secondary;
    font-weight: 500;
  }

  &:indeterminate { color: $text-secondary-disabled; }
}


/***********
 * Dialogs *
 ***********/
messagedialog { // Message Dialog styling
  &.background { background-color: $surface; }

  .titlebar {
    min-height: $small-size;
    border-style: none;
    box-shadow: inset 0 1px highlight($surface);
    background-color: $surface;
    color: $text;

    &:backdrop { color: $text-secondary; }
  }

  &.csd { // rounded bottom border styling for csd version
    &.background {
      // bigger radius for better antialiasing
      border-bottom-left-radius: $corner-radius;
      border-bottom-right-radius: $corner-radius;
    }

    .dialog-action-area {
      margin-top: -$container-padding;
      padding: $container-padding;

      button {
        @extend %simple_flat_button;
        border-radius: $corner-radius;

        &:not(:last-child) { margin-right: $container-padding; }

        &.suggested-action:not(:disabled) { color: $suggested; }

        &.destructive-action:not(:disabled) { color: $destructive; }
      }
    }
  }
}

filechooser {
  .dialog-action-box { border-top: 1px solid $border; }

  #pathbarbox {
    border-bottom: 1px solid $border;
    background-color: $background;

    > stack > box > button { // The new folder button
      @extend %button_basic.flat;
      @extend %circular_button;
    }
  }
}

filechooserbutton:drop(active) {
  box-shadow: none;
}


/***********
 * Sidebar *
 ***********/
.sidebar {
  border-style: none;
  background-color: $base-alt;

  &:not(separator) {
    @at-root %sidebar_left,
    &:dir(ltr),
    &.left,
    &.left:dir(rtl) {
      border-right: 1px solid $border;
      border-left-style: none;
    }

    @at-root %sidebar_right,
    &:dir(rtl),
    &.right {
      border-left: 1px solid $border;
      border-right-style: none;
    }
  }

  list { background-color: transparent; }

  paned & { &.left, &.right, &.left:dir(rtl), &:dir(rtl), &:dir(ltr), & { border-style: none; }}
}

stacksidebar {
  &.sidebar {
    &:dir(ltr),
    &.left,
    &.left:dir(rtl) { list { @extend %sidebar_left; }}

    &:dir(rtl),
    &.right { list { @extend %sidebar_right; }}
  }

  row {
    padding: 10px 4px;

    > label {
      padding-left: 6px;
      padding-right: 6px;
    }

    &.needs-attention > label { @extend %needs_attention; }
  }
}

separator.sidebar {
  background-color: $border;

  &.selection-mode,
  .selection-mode & {
    // background-color: $border;
  }
}


/****************
 * File chooser *
 ****************/
// dim the sidebar icons, see bug #786613 for details on this oddity
row {
  image.sidebar-icon { color: $text-secondary; }
}

placessidebar {
  > viewport.frame { border-style: none; }

  list { padding: (4px - 3px) 0 4px; }

  row {
    // Needs overriding of the GtkListBoxRow padding
    min-height: 32px;
    margin: -1px 4px; // Remove unwanted hard-coded vertical margins with -1px
    padding: 0;
    border-radius: $corner-radius;

    // Using margins/padding directly in the SidebarRow
    // will make the animation of the new bookmark row jump
    > revealer { padding: 0 8px; }

    &:selected { font-weight: 500; }

    &:disabled { color: $text-disabled; }

    image.sidebar-icon {
      &:dir(ltr) { padding-right: 8px; }
      &:dir(rtl) { padding-left: 8px; }
    }

    label.sidebar-label {
      &:dir(ltr) { padding-right: 2px; }
      &:dir(rtl) { padding-left: 2px; }
    }

    &:selected image.sidebar-icon,
    &:selected label.sidebar-label { color: inherit; }

    @at-root button.sidebar-button {
      @extend %simple_flat_button;
      @extend %small_button;
    }

    &.sidebar-placeholder-row {
      min-height: 2px;
      padding: 0 8px;
      background-image: image($primary);
      background-clip: content-box;
    }

    &.sidebar-new-bookmark-row { color: $primary; }

    &:drop(active):not(:disabled) {
      box-shadow: inset 0 0 0 2px $primary;
    }
  }
}

placesview {
  .server-list-button > image { -gtk-icon-transform: rotate(0turn); }

  .server-list-button:checked > image { -gtk-icon-transform: rotate(-0.5turn); }

  // this selects the "connect to server" label
  > actionbar > revealer > box > label {
    padding-left: 8px;
    padding-right: 8px;
  }
}


/*********
 * Paned *
 *********/
paned {
  > separator {
    min-width: 1px;
    min-height: 1px;
    -gtk-icon-source: none; // defeats the ugly default handle decoration
    border-style: none; // just to be sure
    background-color: transparent;
    // workaround, using background istead of a border since the border will get rendered twice (?)
    background-image: image($border);
    background-size: 1px 1px;
    background-clip: content-box; // avoids borders image being rendered twice (?)

    &.wide {
      min-width: 6px;
      min-height: 6px;
      background-color: $background;
      background-image: image($border), image($border);
      background-size: 1px 1px, 1px 1px;
    }
  }

  &.horizontal > separator {
    background-repeat: repeat-y;

    &:dir(ltr) {
      margin: 0 -8px 0 0;
      padding: 0 8px 0 0;
      background-position: left;
    }

    &:dir(rtl) {
      margin: 0 0 0 -8px;
      padding: 0 0 0 8px;
      background-position: right;
    }

    &.wide {
      margin: 0;
      padding: 0;
      background-repeat: repeat-y, repeat-y;
      background-position: left, right;
    }
  }

  &.vertical > separator {
    margin: 0 0 -8px 0;
    padding: 0 0 8px 0;
    background-repeat: repeat-x;
    background-position: top;

    &.wide {
      margin: 0;
      padding: 0;
      background-repeat: repeat-x, repeat-x;
      background-position: bottom, top;
    }
  }
}


/**************
 * GtkInfoBar *
 **************/
infobar {
  border-style: none;

  &.info { background-color: $infobar-info; }

  &.question { background-color: $infobar-question; }

  &.warning { background-color: $infobar-warning; }

  &.error { background-color: $infobar-error; }

  &.info,
  &.question,
  &.warning,
  &.error {
    > label, & { color: on(dark); }

    button { @extend %button_selected; }

    selection {}

    *:link { color: on(dark); }
  }
}


/************
 * Tooltips *
 ************/
tooltip {
  &.background {
    // background-color needs to be set this way otherwise it gets drawn twice
    // see https://bugzilla.gnome.org/show_bug.cgi?id=736155 for details.
    background-color: $tooltip;
    color: on($tooltip);
  }

  // padding: 4px; /* not working */
  border-radius: $corner-radius;
  box-shadow: none; // otherwise it gets inherited by windowframe.csd

  &:not(.csd):not(.unity-csd) {
    // border: 1px solid $border;
    // border-radius: $corner-radius + 1px;
    // background-clip: $background-clip-extra;
  }

  // FIXME: we need a border or tooltips vanish on black background.
  decoration { background-color: transparent; }

  label {
    // tooltip label already seems to have 6px margins
    min-height: 32px - 6px * 2;
    padding: 0 8px - 6px;
  }

  * {
    // workaround for Eclipse.
    // do not include any declaration here.
    // padding: 0;
    // background-color: transparent;
    // color: inherit;
  }
}


/*****************
 * Color Chooser *
 *****************/
colorswatch {
  // This widget is made of two boxes one on top of the other, the lower box is colorswatch {} the other one
  // is colorswatch overlay {}, colorswatch has the programmatically set background, so most of the style is
  // applied to the overlay box.

  // base color corners rounding
  // to avoid the artifacts caused by rounded corner anti-aliasing the base color
  // sports a bigger radius.
  // nth-child is needed by the custom color strip.

  &.top {
    border-top-left-radius: $corner-radius + 0.5px;
    border-top-right-radius: $corner-radius + 0.5px;

    overlay {
      border-top-left-radius: $corner-radius;
      border-top-right-radius: $corner-radius;
    }
  }

  &.bottom {
    border-bottom-left-radius: $corner-radius + 0.5px;
    border-bottom-right-radius: $corner-radius + 0.5px;

    overlay {
      border-bottom-left-radius: $corner-radius;
      border-bottom-right-radius: $corner-radius;
    }
  }

  &.left,
  &:first-child:not(.top) {
    border-top-left-radius: $corner-radius + 0.5px;
    border-bottom-left-radius: $corner-radius + 0.5px;

    overlay {
      border-top-left-radius: $corner-radius;
      border-bottom-left-radius: $corner-radius;
    }
  }

  &.right,
  &:last-child:not(.bottom) {
    border-top-right-radius: $corner-radius + 0.5px;
    border-bottom-right-radius: $corner-radius + 0.5px;

    overlay {
      border-top-right-radius: $corner-radius;
      border-bottom-right-radius: $corner-radius;
    }
  }

  &.dark { color: on(dark); }

  &.light { color: on(light); }

  &:drop(active) {
    box-shadow: none;

    &.light overlay { box-shadow: $shadow-1, 0 0 0 2px $primary; }

    &.dark overlay { box-shadow: $shadow-1, 0 0 0 2px $primary; }
  }

  overlay {
    transition: $transition-shadow;
    box-shadow: $shadow-1;

    &:hover { box-shadow: $shadow-2; }
  }

  &#add-color-button {
    border-radius: $corner-radius $corner-radius 0 0;
    color: on(dark);

    &:only-child { border-radius: $corner-radius; }

    overlay {
      background-image: linear-gradient(to right,
                                        $red 25%,
                                        $yellow 25%, $yellow 50%,
                                        $green 50%, $green 75%,
                                        $blue 75%);
    }
  }

  &:disabled {
    opacity: 0.5;

    overlay { box-shadow: none; }
  }

  row:selected & {
  }

  &#editor-color-sample {
    border-radius: $corner-radius + 0.5px;

    overlay { border-radius: $corner-radius; }

    // overlay:hover { box-shadow: $shadow-1; }
  }
}

// colorscale popup
colorchooser .popover.osd {
  transition: $transition-shadow;
  border-radius: $corner-radius;
  box-shadow: $shadow-2, inset 0 1px highlight($surface);
  background-color: $surface;

  &:backdrop { box-shadow: $shadow-1, inset 0 1px highlight($surface); }
}


/********
 * Misc *
 ********/
// content view (grid/list)
.content-view {
  background-color: $background;

  // &:hover { -gtk-icon-effect: highlight; }

  rubberband, .rubberband { @extend rubberband; }
}

.scale-popup {
  // .osd & { @extend %osd; }

  .osd & button.flat { // FIXME: quick hack, redo properly
  }

  button { // +/- buttons on GtkVolumeButton popup
  }
}


/**********************
 * Window Decorations *
 **********************/
decoration {
  transition: $transition-shadow;
  border-radius: $corner-radius $corner-radius 0 0;
  box-shadow: $shadow-4, 0 16px 16px transparent;

  // FIXME rationalize shadows

  // this is used for the resize cursor area
  margin: 8px;

  &:backdrop {
    // the transparent shadow here is to enforce that the shadow extents don't
    // change when we go to backdrop, to prevent jumping windows.
    // The biggest shadow should be in the same order then in the active state
    // or the jumping will happen during the transition.
    box-shadow: $shadow-2, 0 16px 16px transparent;
  }

  .maximized &,
  .fullscreen &,
  .tiled &,
  .tiled-top &,
  .tiled-right &,
  .tiled-bottom &,
  .tiled-left & { border-radius: 0; }

  .popup & { box-shadow: none; }

  // server-side decorations as used by mutter
  .ssd & { box-shadow: 0 3px 3px rgba(0, 0, 0, 0.16); } // just doing borders, wm draws actual shadows

  .csd.popup & {
    border-radius: $corner-radius;
    box-shadow: $shadow-2;
  }

  tooltip.csd & {
    border-radius: $corner-radius;
    box-shadow: none;
  }

  messagedialog.csd & {
    border-radius: $corner-radius;
    // box-shadow: $shadow-4, 0 16px 16px transparent;

    // &:backdrop { box-shadow: $shadow-2, 0 16px 16px transparent; }
  }

  .solid-csd & {
    margin: 0;
    // padding: 4px;
    border-radius: 0;
    box-shadow: none;
    // box-shadow: inset 0 0 0 4px $titlebar;
    background-color: $titlebar;
  }
}

// Window Close button
button.titlebutton {
  // @extend %simple_flat_button;

  @extend %circular_button;

  .selection-mode & {
  }
}


// catch all extend :)

%selected_items {
  background-color: $overlay-selected;
}

.monospace { font-family: monospace; }


/**********************
 * Touch Copy & Paste *
 **********************/
// touch selection handlebars for the Popover.osd above
cursor-handle {
  color: $primary;
  -gtk-icon-source: -gtk-recolor(url("assets/scalable/cursor-handle-symbolic.svg"));

  &.top:dir(ltr), &.bottom:dir(rtl) {
    -gtk-icon-transform: rotate(90deg);
  }

  &.bottom:dir(ltr), &.top:dir(rtl) {
    -gtk-icon-transform: unset;
  }

  &.insertion-cursor:dir(ltr), &.insertion-cursor:dir(rtl) {
    padding-top: 6px;
    -gtk-icon-transform: rotate(45deg);
  }
}

.context-menu { font: initial; } // Decouple the font of context menus from their entry/textview

// shortcut window keys
.keycap {
  min-width: 28px - 8px * 2;
  min-height: 28px - 2px;
  margin-top: 2px;
  padding-bottom: 2px;
  padding-left: 8px;
  padding-right: 8px;

  border: solid 1px $border;
  border-radius: $corner-radius + 1px;
  box-shadow: inset 0 -2px $border;
  background-color: $surface;
  color: $text;
  font-size: smaller;
}

:not(decoration):not(window):drop(active) { // FIXME needs to be done widget by widget, this wildcard should really die
  transition: $transition;
  box-shadow: $shadow-1, inset 0 0 0 2px $primary;
  caret-color: $primary;
}

stackswitcher button.text-button { min-width: 100px; } // FIXME aggregate with buttons

stackswitcher button.circular,
stackswitcher button.text-button.circular { // FIXME aggregate with buttons
  min-width: $medium-size;
  min-height: $medium-size;
  padding: 0;
}


/*************
 * App Icons *
 *************/
// Outline for low res icons
.lowres-icon {
  // -gtk-icon-shadow: none;
}

// Drapshadow for large icons
.icon-dropshadow {
  // -gtk-icon-shadow: none;
}


/*********
 * Emoji *
 *********/
popover.emoji-picker {
  padding: 0;

  entry {
    border-bottom: 1px solid $border;
    border-image: none;
    border-radius: 0;
    box-shadow: none;
    background-color: transparent;
  }

  scrolledwindow { border-bottom: 1px solid $border; }
}

// mimic tab style
button.emoji-section {
  margin-top: -1px;
  padding: 0 8px;
  min-width: 24px;
  min-height: $medium-size;
  border-radius: 0;
  outline-offset: -6px;

  &, &:hover, &:active { box-shadow: inset 0 2px transparent; }

  &:checked {
    box-shadow: inset 0 2px $primary;
    background-color: transparent;
  }

  &:hover, &:active { background-color: $overlay-hover; }

  &:first-child { margin-left: 4px; }

  &:last-child { margin-right: 4px; }
}

popover.emoji-picker .emoji {
  min-width: 3em;
  min-height: 3em;
  padding: 0 8px;
  // font-size: larger;

  widget {
    transition: $transition;
    border-radius: $corner-radius;

    &:hover { background-color: $overlay-hover; }
  }
}

popover.emoji-completion {
  padding: 8px 0;

  arrow {
    border: none;
    background: none;
  }

  .emoji-completion-row {
    min-height: $menuitem-size;
    padding: 0 12px;
  }

  .emoji:hover {
    background-color: $overlay-hover;
  }
}
